Demo.App/Models/Product.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Demo.App.Models
{
    public class Product
    {
        public int Id { get; set; }
        public string Description { get; set; }
        [Required]
        public string Name { get; set; }
        [Required]
        public decimal Price { get; set; }

        public string Image { get; set; }

        public int? Quantity { get; set; }
    }
}

Demo.App/Models/User.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Demo.App.Models
{
    public class User
    {
        [Required]
        public string Username { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
    }
}

Demo.App/Pages/Error.cshtml.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace Demo.App.Pages
{
    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public class ErrorModel : PageModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);

        private readonly ILogger<ErrorModel> _logger;

        public ErrorModel(ILogger<ErrorModel> logger)
        {
            _logger = logger;
        }

        public void OnGet()
        {
            RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier;
        }
    }
}

Demo.App/Pages/Index.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Demo.App.Models;
using Demo.App.Persistence;
using Demo.App.Services;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace Demo.App.Pages
{
    public class IndexModel : PageModel
    {
        private readonly ILogger<IndexModel> _logger;
        private readonly IProductRepository _products;
        private readonly IProductsService _productsService;

        [TempData]
        public string VrstaPoruke { get; set; }

        [TempData]
        public string Poruka { get; set; }
        public List<Product> Proizvodi { get; set; }

        [BindProperty]
        public Product Proizvod { get; set; }

        public IndexModel(ILogger<IndexModel> logger, 
            IProductRepository products, IProductsService productsService)
        {
            _logger = logger;
            _products = products;
            _productsService = productsService;

            Proizvodi = productsService.GetProductsAsync().Result;
        }

  
        public void OnGet()
        {

        }

        public async Task<IActionResult> OnPostAddProduct()
        {
            if(!ModelState.IsValid)
            {
                VrstaPoruke = "danger";
                Poruka = "Neispravan unos!";

                return Page();
            }

            try
            {
                await _productsService.CreateProduct(Proizvod);
            }
            catch(Exception ex)
            {
                Console.WriteLine($"Dogodila se pogreška tokom dodavanja proizvoda:{ex}");
                VrstaPoruke = "error";
                Poruka = "Dogodila se pogreška prilikom dodavanja proizvoda!";
                return Page();
            }

            VrstaPoruke = "success";
            Poruka = "Uspješno dodan proizvod!";
            return RedirectToPage("Index");
        }

        public void OnGetEditProduct(int indeks)
        {
            var proizvod = Proizvodi[indeks];
            Proizvod = proizvod;
        }

        public IActionResult OnPostUpdateProduct(int id)
        {
            if (!ModelState.IsValid)
            {
                // Ispiši mi neku grešku
                Poruka = "Neispravan unos!";
                return Page();
            }

            //var product = _db.Products.Where(p => p.Id == id).First();
            //product.Image = Proizvod.Image;
            //product.Name = Proizvod.Name;
            //product.Price = Proizvod.Price;

            //_db.Products.Update(product);
            //_db.SaveChanges();

            //_db.Entry(Proizvod).State = Microsoft.EntityFrameworkCore.EntityState.Modified;
            //_db.SaveChanges();

            Poruka = "Uspješno ažuriran proizvod!";
            VrstaPoruke = "success";

            return RedirectToPage("Index");
        }


        public IActionResult OnGetDeleteProduct(int id)
        {
            //var product = _db.Products.Where(p => p.Id == id).First();
            //try
            //{
                
            //    _db.Products.Remove(product);
            //    _db.SaveChanges();
            //}
            //catch(Exception ex)
            //{
            //    Poruka = $"Dogodila se pogreška prilikom brisanja proizvoda: {product.Name}!";
            //    _logger.LogError(ex, Poruka);
                
            //    VrstaPoruke = "danger";
            //    return Page();
            //}

            //Poruka = $"Uspješno obrisan proizvod {product.Name}!";
            VrstaPoruke = "success";

            return RedirectToPage("Index");
        }
    }
}

Demo.App/Pages/Privacy.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace Demo.App.Pages
{
    public class PrivacyModel : PageModel
    {
        private readonly ILogger<PrivacyModel> _logger;

        public PrivacyModel(ILogger<PrivacyModel> logger)
        {
            _logger = logger;
        }

        public void OnGet()
        {
        }
    }
}

Demo.App/Pages/Index.cshtml
@page "{handler?}"
@addTagHelper *, Demo.App.TagHelpers
@model IndexModel
@{
    ViewData["Title"] = "Unos proizvoda";
}

<div class="text-center">
    <h1 class="display-4">Proizvodi</h1>
</div>

@if (!string.IsNullOrWhiteSpace(Model.Poruka))
{
    <div class="alert alert-@Model.VrstaPoruke">
        @Model.Poruka
    </div>
}

@if (Model.Proizvod != null)
{
    <form method="post">
        <fieldset>
            <legend>Ažuriranje proizvoda</legend>
            <div class="form-group">
                <label>Ime</label>
                <input asp-for="@Model.Proizvod.Name" />
                <span asp-validation-for="@Model.Proizvod.Name"></span>
            </div>
            <div class="form-group">
                <label>Opis</label>
                <input asp-for="@Model.Proizvod.Description" />
                <span asp-validation-for="@Model.Proizvod.Description"></span>
            </div>
            <div class="form-group">
                <label>Cijena</label>
                <input asp-for="@Model.Proizvod.Price" />
                <span asp-validation-for="@Model.Proizvod.Price"></span>
            </div>


            <button type="submit" class="btn btn-primary" asp-page-handler="UpdateProduct" asp-route-id="@Model.Proizvod.Id">Ažuriraj proizvod</button>
        </fieldset>

    </form>
}
else
{
    <div>
        <form method="post">
            <fieldset>
                <legend>Unos proizvoda</legend>
                <div class="form-group">
                    <label>Ime</label>
                    <input asp-for="@Model.Proizvod.Name" />
                    <span asp-validation-for="@Model.Proizvod.Name"></span>
                </div>
                <div class="form-group">
                    <label>Opis</label>
                    <input asp-for="@Model.Proizvod.Description" />
                    <span asp-validation-for="@Model.Proizvod.Description"></span>
                </div>
                <div class="form-group">
                    <label>Cijena</label>
                    <input asp-for="@Model.Proizvod.Price" />
                    <span asp-validation-for="@Model.Proizvod.Price"></span>
                </div>

                <button type="submit" class="btn btn-primary" asp-page-handler="AddProduct">Unesi proizvod</button>
            </fieldset>

        </form>
    </div>
}

<br />
@*<div>
        <form method="post">
            <fieldset>
                <legend>Unos korisnika</legend>
                <label>Username</label>
                <input type="text" class="form-control" name="Username" /><br />
                <label>Ime</label>
                <input type="text" class="form-control" name="FirstName" /><br />
                <label>Prezime</label>
                <input type="text" class="form-control" name="LastName" /><br />
                <button class="button" asp-page-handler="AddUser">Unesi korisnika</button>
            </fieldset>

        </form>
    </div>
    <br/>*@

@if (Model != null && Model.Proizvodi != null)
{
    <table class="table">
        @for (int i = 0; i < Model.Proizvodi.Count(); i++)
        {
            <tr>
                <td>@Model.Proizvodi[i].Name</td>
                <td>@Model.Proizvodi[i].Description</td>
                <td>@Model.Proizvodi[i].Price</td>
                <td>
                    <a asp-page-handler="EditProduct" asp-route-indeks="@i">Odaberi</a>
                    <a asp-page-handler="DeleteProduct"
                       onclick="return confirm('Jeste li sigurni da želite obrisati ovaj proizvod?')"
                       asp-route-id="@Model.Proizvodi[i].Id">Obriši</a>
                </td>
            </tr>
        }
    </table>
}

<email mail-to="support" domain="gmail.com" title="Kontaktirajte nas"></email>
<!--
<a href="mailto:support@domena.com">Kontaktirajte nas</a>-->


@section scripts {
    @await Html.PartialAsync("_ValidationScriptsPartial")
}

Demo.App/Pages/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Demo.App</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-page="/Index">Demo.App</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-page="/Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-page="/Privacy">Privacy</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-page="/Test">Test</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2019 - Demo.App - <a asp-area="" asp-page="/Privacy">Privacy</a>
        </div>
    </footer>

    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>

    @RenderSection("Scripts", required: false)
</body>
</html>